////////////
// Rocket //
////////////
datablock ParticleData(guidedRocketTrailParticle : rocketTrailParticle)
{
   colors[0]     = "1 0 1 0.4";
   colors[1]     = "0.2 0 1 0.5";
   colors[2]     = "0.20 0.20 0.20 0.3";
   colors[3]     = "0.0 0.0 0.0 0.0";
   lifetimeMS = 2000;
};
datablock ParticleEmitterData(guidedRocketTrailEmitterB : rocketTrailEmitter)
{
   particles = "guidedRocketTrailParticle";
};

datablock ProjectileData(guidedRocketLauncherProjectile)
{
   projectileShapeName = "Add-Ons/Projectile_GravityRocket/RocketGravityProjectile.dts";
   directDamage        = 30;
   directDamageType = $DamageType::RocketDirect;
   radiusDamageType = $DamageType::RocketRadius;
   impactImpulse	   = 1000;
   verticalImpulse	   = 1000;
   explosion           = rocketExplosion;
   particleEmitter     = guidedRocketTrailEmitterB;

   brickExplosionRadius = 3;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 30;             
   brickExplosionMaxVolume = 30;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 60;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   sound = errorSound;

   muzzleVelocity      = 40;
   velInheritFactor    = 1.0;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "0 0.1 0.6";

   uiName = "Rocket, guided";
};

//guidelaser
datablock ProjectileData(guidelaserProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 0;
   directDamageType    = $DamageType::Generic;
   radiusDamageType    = $DamageType::Generic;
   
   particleEmitter = guidelaserEmitter;
   
   soundProfile = radioWaveTravelSound;

   brickExplosionRadius = 0;
   brickExplosionImpact = 0;             //destroy a brick if we hit it directly?
   brickExplosionForce  = 0;             
   brickExplosionMaxVolume = 0;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 0;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   collideWithPlayers = true;

   muzzleVelocity      = 1;
   velInheritFactor    = 1.0;

   armingDelay         = 4000;
   lifetime            = 4000;
   fadeDelay           = 4000;
   bounceElasticity    = 0;
   bounceFriction      = 0.00;
   isBallistic         = true;
   gravityMod          = 0.0;

   hasLight    = false;
   lightRadius = 1;
   lightColor = "0.01 0 0";
   
   uiName = "Guiding laser";
};

datablock ParticleData(guidelaserParticle)
{
   dragCoefficient      = 5;
   gravityCoefficient   = -0.0;
   inheritedVelFactor   = 1.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 100;
   lifetimeVarianceMS   = 0;
   textureName          = "base/data/particles/dot";
   spinSpeed           = 0.0;
   spinRandomMin        = 0.0;
   spinRandomMax        = 0.0;
   colors[0]     = "1 1 0 0.9";
   colors[1]     = "1 0 0 0.5";
   colors[2]     = "1 0 0 0";

   sizes[0]      = 0.15;
   sizes[1]      = 0.15;
   sizes[2]      = 0.3;

   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;

   useInvAlpha = false;
};

datablock ParticleEmitterData(guidelaserEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 1;
   velocityVariance = 0.5;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "guidelaserParticle";

   useEmitterColors = false;
};


//////////
// item //
//////////
datablock ItemData(guidedrocketlauncherItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "Add-Ons/Weapon_Rocket_Launcher/rocketLauncher.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "MAS Guided RL.";
	iconName = "./icon_rocketLauncher";
	doColorShift = true;
	colorShiftColor = "1 0 0 1";

	 // Dynamic properties defined by the scripts
	image = guidedrocketLauncherImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(guidedrocketlauncherImage)
{
   // Basic Item properties
   shapeFile = "Add-Ons/Weapon_Rocket_Launcher/rocketLauncher.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = guidedRocketLauncherProjectile;
   projectileType = Projectile;

	//casing = guidedrocketLauncherShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;
   minShotTime = 700;   //minimum time allowed between shots (needed to prevent equip/dequip exploit)

   doColorShift = true;
   colorShiftColor = guidedrocketLauncherItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 0.1;
	stateTransitionOnTimeout[0]       	= "Ready";
	stateSound[0]				= weaponSwitchSound;

	stateName[1]                     	= "Ready";
	stateTransitionOnTriggerDown[1]  	= "Fire";
	stateAllowImageChange[1]         	= true;
   	stateTransitionOnNoAmmo[1]      	= "Reload";
	stateSequence[1]			= "Ready";

	stateName[2]                    	= "Fire";
	stateSequence[2] 			= "Fire";
	stateTransitionOnTimeout[2]     	= "Ready";
	stateTimeoutValue[2]            	= 0.5;
	//stateFire[2]                    	= true;
	stateAllowImageChange[2]        	= false;
	stateSequence[2]                	= "Fire";
	stateScript[2]                  	= "onFire";
	stateWaitForTimeout[2]			= true;
};

function guidedRocketLauncherImage::onFire(%this,%obj,%slot)
{
	if((%obj.lastFireTime+%this.minShotTime) > getSimTime())
		return;
	%obj.lastFireTime = getSimTime();
	
	%obj.mountImage(guidedRocketLauncherImageLaser,0);

	%projectile = "guidedRocketLauncherProjectile";
	%spread = 0.001;
	%shellcount = 1;
	%scaleFactor = getWord(%obj.getScale(),2)/2;
	
	%client = %obj.client;
	%pos = %obj.getHackPosition();

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
		%p.setScale(%scaleFactor SPC %scaleFactor SPC %scaleFactor);
		%obj.guiderocket = %p;
		%p.guider = %obj;
	}
	return %p;
}

//laserweapon
datablock ShapeBaseImageData(guidedrocketlauncherImageLaser)
{
   // Basic Item properties
   shapeFile = "Add-Ons/Weapon_Rocket_Launcher/rocketLauncher.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = guidelaserProjectile;
   projectileType = Projectile;

	//casing = guidedrocketLauncherShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   raycastWeaponRange = 9001;
   raycastWeaponTargets =
                   $TypeMasks::PlayerObjectType |    //AI/Players
                   $TypeMasks::StaticObjectType |    //Static Shapes
                   $TypeMasks::TerrainObjectType |    //Terrain
                   $TypeMasks::VehicleObjectType |    //Terrain
                   $TypeMasks::FXBrickObjectType;    //Bricks
   raycastExplosionProjectile = guidelaserProjectile;
   raycastExplosionBrickSound = "";
   raycastExplosionPlayerSound = "";
   raycastDirectDamage = 0;
   raycastDirectDamageType = $DamageType::EightEightyRifle;
   
   doColorShift = true;
   colorShiftColor = guidedrocketLauncherItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 0.1;
	stateTransitionOnTimeout[0]       	= "Fire";
	stateSound[0]						= weaponSwitchSound;

	stateName[1]                    	= "Fire";
	stateSequence[1] 					= "Fire";
	stateTransitionOnTimeout[1]     	= "Fire";
	stateTimeoutValue[1]            	= 0.1;
	stateFire[1]                    	= true;
	stateAllowImageChange[1]        	= false;
	stateSequence[1]                	= "Fire";
	stateScript[1]                  	= "onFire";
	stateWaitForTimeout[1]				= true;
};

function guidedRocketLauncherImageLaser::onFire(%this,%obj,%slot)
{
	Parent::onFire(%this,%obj,%slot);
	if(!isObject(%obj.guiderocket))
	{
		%obj.unmountImage(0);
		%obj.mountImage(guidedRocketLauncherImage,0);
	}
}

function guidedRocketLauncherImageLaser::onHitObject(%this,%obj,%slot,%col,%pos,%normal,%shotVec,%crit)
{
	Parent::onHitObject(%this,%obj,%slot,%col,%pos,%normal,%shotVec,%crit);
	if(!isObject(%col))
		return;
	%obj.guiderocket.guidepos = %pos;
}

function guidedRocketLauncherImageLaser::onUnMount(%this,%obj,%slot)
{
	if(isObject(%obj.guiderocket))
	{
		%obj.guiderocket.explode();
	}
}

package guidedRocket
{
	function Projectile::onAdd(%obj,%a,%b)
	{
		Parent::onAdd(%obj,%a,%b);
		if(%obj.dataBlock.getID() == guidedRocketLauncherProjectile.getID())
		{
			if(!%obj.doneguidedDelay)
				%obj.schedule(150,spawnguidedRocket);
			else
				%obj.schedule(75,spawnguidedRocket);
		}
	}
};
activatePackage(guidedRocket);

function Projectile::spawnguidedRocket(%this)
{
	if(!isObject(%this.client))
		return;

	if(!isObject(%this) || vectorLen(%this.getVelocity()) == 0)
		return;

	%client = %this.client;
	%muzzle = vectorLen(%this.getVelocity());
	
	%pos = %this.getPosition();
	%start = %this.getPosition();
	%end = %this.guidepos;
	%vec = vectorNormalize(vectorSub(%end,%start));
	
	%addVec = vectorAdd(%this.getVelocity(),vectorScale(%vec,180/vectorDist(%pos,%end)*(%muzzle/10)));
	%vec = vectorNormalize(%addVec);
	
	%p = new Projectile()
	{
		dataBlock = %this.dataBlock;
		initialPosition = %pos;
		initialVelocity = vectorScale(%vec,%muzzle);
		sourceObject = %this.sourceObject;
		client = %this.client;
		sourceSlot = 0;
		originPoint = %this.originPoint;
		doneguidedDelay = 1;
		reflectTime = %this.reflectTime;
	};
	if(isObject(%p))
	{
		MissionCleanup.add(%p);
		%p.setScale(%this.getScale());
		%p.guider = %this.guider;
		%this.guider.guiderocket = %p;
		%this.delete();
	}
}
